library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


entity And_gen_CT_sel is 

	generic (l: integer := 5 ; n: integer := 3);	
	
	port ( dec_add        : in std_logic_vector(2**l -3 downto 0);
		    singolo_CT_sel : in std_logic_vector (n-1 downto 0);
			 CT_vettore_out : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0));
				
end And_gen_CT_sel;


architecture Behavioral of And_gen_CT_sel is


component and_N_1 is 

	generic (k	: integer := 5);	
	
	port ( Enable         : in std_logic;
		    ingresso       : in std_logic_vector (k-1 downto 0);
			 uscita         : out std_logic_vector(k-1 downto 0));
				
end component and_N_1;


begin


Gen: for i in 2 to (2**l)-1 generate

      And_i : and_N_1
		        generic map (calcolo_k(i,n))	 
				  port map (dec_add(i-2),  singolo_CT_sel(calcolo_k(i,n)-1 downto 0), CT_vettore_out(indice_CT_sel(i,n)-2 downto indice_CT_sel(i,n)-calcolo_k(i,n)-1));	

end generate Gen;

end behavioral; 
