library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


entity And_gen_ST_sel is 

	generic (l: integer := 3 ; n: integer := 3);	
	
	port ( dec_add        : in std_logic_vector(2**l -3 downto 0);
		    singolo_ST_sel : in std_logic_vector (grandezza_gen_ST_out(n)-1 downto 0);
			 ST_vettore_out : out std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0));
				
end And_gen_ST_sel;


architecture Behavioral of And_gen_ST_sel is


component and_N_1 is 

	generic (k	: integer := 5);	
	
	port ( Enable         : in std_logic;
		    ingresso       : in std_logic_vector (k-1 downto 0);
			 uscita         : out std_logic_vector(k-1 downto 0));
				
end component and_N_1;


begin


Gen: for i in 2 to (2**l)-1 generate

      	Gen1 : if (i mod 2) = 0 generate

                And_i : and_N_1
		                  generic map (calcolo_k(i,n)*integer(ceil(log2(real(calcolo_k(i,n))))))	 
				            port map (dec_add(i-2), singolo_ST_sel( (grandezza_gen_ST_out(calcolo_k(i,n)-1)) +(calcolo_k(i,n)*integer(ceil(log2(real(calcolo_k(i,n)))))) -1 downto (grandezza_gen_ST_out(calcolo_k(i,n)-1))), ST_vettore_out(indice_ST_sel(i,n)-1 downto indice_ST_sel(i,n)-calcolo_k(i,n)*integer(ceil(log2(real(calcolo_k(i,n)))))));	

end generate Gen1;

end generate Gen;

end behavioral; 
