library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


entity And_gen_muxin_sel_bidirezionale is 

	generic (l: integer := 4 ; n: integer := 4);	
	
	port ( dec_add           : in std_logic_vector(2**l -1 downto 0);
		    singolo_muxin_sel : in std_logic_vector(integer(ceil(log2(real(n))))-1 downto 0);
			 muxin_sel_out     : out std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0));
				
end And_gen_muxin_sel_bidirezionale;


architecture Behavioral of And_gen_muxin_sel_bidirezionale is


component and_N_1 is 

	generic (k	: integer := 5);	
	
	port ( Enable         : in std_logic;
		    ingresso       : in std_logic_vector (k-1 downto 0);
			 uscita         : out std_logic_vector(k-1 downto 0));
				
end component and_N_1;


begin


Gen: for i in 1 to (2**l) generate

    	Gen_1 : if (i mod 2) = 0 generate

      And_i : and_N_1
		        generic map (integer(ceil(log2(real(calcolo_k(i,n))))))	 
				  port map (dec_add(i-1),  
				            singolo_muxin_sel(integer(ceil(log2(real(calcolo_k(i,n)))))-1 downto 0), 
							   muxin_sel_out(indice_mux_sel_bid(i,n)-1 downto indice_mux_sel_bid(i,n)-integer(ceil(log2(real(calcolo_k(i,n)))))));	

end generate Gen_1;
end generate Gen;

end behavioral; 