library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;


ENTITY B_B IS


 GENERIC (k_ct : POSITIVE :=3 ; k_st : POSITIVE :=3 ; n : integer :=6);

	PORT( ST_sel :  in std_logic_vector(k_st*integer(ceil(log2(real(k_st))))-1 downto 0);
	      CT_sel :  in std_logic_vector(k_ct-1 downto 0);
		   B_B_in :  in std_logic_vector(n-1 downto 0);
			Cell_in:	 in std_logic;
		   B_B_out:  out std_logic_vector(n-1 downto 0));
END B_B;


architecture behavioral of B_B is



Component Switch_T IS

 GENERIC (k : POSITIVE :=4 ; n : integer :=6);
 
	PORT( ST_sel :  in std_logic_vector(k*integer(ceil(log2(real(k))))-1 downto 0);
		   ST_in:    in std_logic_vector(n-1 downto 0);
		   ST_out:   out std_logic_vector(n-1 downto 0));
			
END component Switch_T;



component Control_T IS

	GENERIC (k : integer :=2 ; n : integer :=4);

	PORT( CT_sel :  in std_logic_vector(k-1 downto 0);
		   Cell_in:	 in std_logic;
		   CT_in:    in std_logic_vector(n-1 downto 0);
		   CT_out:   out std_logic_vector(n-1 downto 0));
			
END component Control_T;

signal ST_out: std_logic_vector(0 to n-1);


begin

ST: Switch_T
    generic map (k_st, n)
	 port map (ST_sel, B_B_in, ST_out);

CT: Control_T
    generic map (k_ct, n)	 
	 port map (CT_sel, Cell_in, ST_out, B_B_out);
	 
end Behavioral;
