library IEEE;
use IEEE.std_logic_1164.all; --  libreria IEEE con definizione tipi standard logic
use IEEE.std_logic_signed.all; 
USE ieee.std_logic_arith.all;

ENTITY Control_T IS

	GENERIC (k : integer :=2 ; n : integer :=4);

	PORT( CT_sel :  in std_logic_vector(k-1 downto 0);
		   Cell_in:	 in std_logic;
		   CT_in:    in std_logic_vector(n-1 downto 0);
		   CT_out:   out std_logic_vector(n-1 downto 0));
END Control_T;

---------------------------------------------

architecture behavioral of Control_T is

component mux_2to1 is
    Port ( SEL : in  STD_LOGIC;
           A   : in  STD_LOGIC;
           B   : in  STD_LOGIC;
           X   : out STD_LOGIC);
end component mux_2to1;

begin

Gen: for i in 0 to n-1 generate

      Gen_1 : if i <= k-1 generate
		
                   mux_2to1_i : mux_2to1 port map (CT_sel(i),Cell_in,CT_in(i),CT_out(i));				  
	   
		end generate Gen_1;
	  
      Gen_2 : if i >= k generate
		
                 	 CT_out(i)<= CT_in(i); 
						 
		end generate Gen_2;
	  			 
end generate Gen;

end Behavioral;
