library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


entity OR_tra_vettori_CT_sel is 

	generic (l: integer := 5 ; X: integer := 5 ; n: integer := 3);	
	
	port ( CT_in    : in std_logic_vector ((X-1)*(indice_CT_sel((2**l)-1,n)-1)-1 downto 0);
			 CT_out   : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0));
				
end OR_tra_vettori_CT_sel;



architecture Behavioral of OR_tra_vettori_CT_sel is


component OR_2_input_CT is 

	generic (l: integer := 5 ; n: integer := 3);	
	
	port ( in_1     : in std_logic_vector (indice_CT_sel((2**l)-1,n)-2 downto 0);
	       in_2     : in std_logic_vector (indice_CT_sel((2**l)-1,n)-2 downto 0);
			 or_out   : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0));
				
end component;


signal  or_out_prov:  std_logic_vector((X-2)*(indice_CT_sel((2**l)-1,n)-1)-1 downto 0);
				

begin



Gen: for i in 0 to x-3 generate


      Gen1 : if i = 0 generate
		
				  OR_2_input_i : OR_2_input_CT
		                       generic map (l,n)	 
				                 port map (CT_in((i+1)*(indice_CT_sel((2**l)-1,n)-1)-1 downto 0),
									            CT_in((i+2)*(indice_CT_sel((2**l)-1,n)-1)-1 downto (i+1)*(indice_CT_sel((2**l)-1,n)-1)), 
													or_out_prov((i+1)*(indice_CT_sel((2**l)-1,n)-1)-1 downto i*(indice_CT_sel((2**l)-1,n)-1)));	

	   
		end generate Gen1;
		
		
		Gen2 : if i > 0 generate
		
				  OR_2_input_i : OR_2_input_CT
		                       generic map (l,n)	 
				                 port map (CT_in((i+2)*(indice_CT_sel((2**l)-1,n)-1)-1 downto (i+1)*(indice_CT_sel((2**l)-1,n)-1)), 
				                           or_out_prov((i)*(indice_CT_sel((2**l)-1,n)-1)-1 downto (i-1)*(indice_CT_sel((2**l)-1,n)-1)),
													or_out_prov((i+1)*(indice_CT_sel((2**l)-1,n)-1)-1 downto i*(indice_CT_sel((2**l)-1,n)-1)));
		
	   
		end generate Gen2;
		

     
end generate Gen;
	
	
CT_out <= or_out_prov((X-2)*(indice_CT_sel((2**l)-1,n)-1)-1 downto (X-3)*(indice_CT_sel((2**l)-1,n)-1));
	

end behavioral; 

