library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;



ENTITY RAM_bid IS
 GENERIC (l : integer := 5; n : integer :=3 ; c : integer :=3);

	PORT( mux_in_sel_down     :  in std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0);
	      mux_in_sel_up       :  in std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0);
			WE                  :  in std_logic_vector((2**l) downto 0);
			clock               :  in std_logic;
			data_in             :  in std_logic_vector(((2**c)*((2**l)+1))-1 downto 0);
			data_or_outmux_sel  :  in std_logic_vector((2**l) downto 0);	
			up_down_sel         :  in std_logic_vector((2**l)-2 downto 0);			
	      mux_outcol_sel_up   :  in std_logic;
		   mux_outcol_sel_down :  in std_logic;
			CT_sel_up           :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1 downto 0);
			ST_sel_up           :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);		
			CT_sel_down         :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1 downto 0);
			ST_sel_down         :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
			Mem_out_down        :  out std_logic_vector((2**c)-1 downto 0);
			Mem_out_up          :  out std_logic_vector((2**c)-1 downto 0));
			
END RAM_bid;



architecture behavioral of RAM_bid is



component colonna_bid IS
 GENERIC (l : integer := 3; n : integer :=3);

	PORT( mux_in_sel_down     :  in std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0);
	      mux_in_sel_up       :  in std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0);
			WE                  :  in std_logic_vector((2**l) downto 0);
			clock               :  in std_logic;
			data_in             :  in std_logic_vector((2**l) downto 0);
			data_or_outmux_sel  :  in std_logic_vector((2**l) downto 0);	
			up_down_sel         :  in std_logic_vector((2**l)-2 downto 0);	
			colonna_out_down    :  out std_logic;
			colonna_out_up      :  out std_logic;			
	      mux_outcol_sel_up   :  in std_logic;
		   mux_outcol_sel_down :  in std_logic;
			CT_sel_up           :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1 downto 0);
			ST_sel_up           :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);		
			CT_sel_down         :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1 downto 0);
			ST_sel_down         :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
		   contenuto_celle     : out std_logic_vector((2**l)  downto 0));
			
END component colonna_bid;


signal colonne :std_logic_vector( (2**c)*((2**l)+1)-1 downto 0);
TYPE matrice IS ARRAY ( 2**l downto 0, 2**c -1 downto 0 ) OF std_logic;
signal matrice_mem : matrice;


begin

Gen: for i in 1 to (2**c) generate
		
                   colonna_bid_i : colonna_bid
						 generic map (l,n)
						 port map (mux_in_sel_down,mux_in_sel_up,WE,clock, data_in ((i*((2**l)+1))-1 downto (i-1)*((2**l)+1)),data_or_outmux_sel, up_down_sel, Mem_out_down(i-1),Mem_out_up(i-1),mux_outcol_sel_up, mux_outcol_sel_down,CT_sel_up,	ST_sel_up ,	CT_sel_down,ST_sel_down,colonne((i)*((2**l)+1)-1 downto (i-1)*((2**l)+1) ) );
			

end generate Gen;


 Gen1: for j in 0 to (2**l)  generate

		    Gen2:  for i in 0 to 2**c-1 generate
		  
               matrice_mem(j,i) <= colonne((i)*(2**l+1)+ j);
					
			 end generate Gen2;
		
                  
end generate Gen1;


end Behavioral;
