library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;

--- per selezionare data_in il selettore deve essere 0.


ENTITY RAM_up_down_v1 IS

 GENERIC (l : integer := 3; n : integer :=3 ; c : integer :=3);

	PORT( mux_in_sel  :  in std_logic_vector(indice_mux_sel(2**l,n)-1 downto 0);
	      mux_out_sel :  in std_logic;
			WE          :  in std_logic_vector((2**l) downto 0);
			clock       :  in std_logic;
			data_in     :  in std_logic_vector(((2**c)*((2**l)+1))-1 downto 0);
			CT_sel      :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1 downto 0);
			ST_sel      :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
		   MEM_out     :  out std_logic_vector((2**c)-1 downto 0));
			
END RAM_up_down_v1;



architecture behavioral of RAM_up_down_v1 is


component colonna_up_down IS
 GENERIC (l : integer := 3; n : integer :=3);

	PORT( mux_in_sel  :  in std_logic_vector(indice_mux_sel(2**l,n)-1 downto 0);
	      mux_out_sel :  in std_logic;
			WE          :  in std_logic_vector((2**l) downto 0);
			clock       :  in std_logic;
			data_in     :  in std_logic_vector((2**l) downto 0);
			CT_sel      :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1 downto 0);
			ST_sel      :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
		   colonna_out :  out std_logic;
			contenuto_celle: out std_logic_vector((2**l)  downto 0));
			
END component colonna_up_down;


signal colonne :std_logic_vector( (2**c)*((2**l)+1)-1 downto 0);
TYPE matrice IS ARRAY ( 2**l downto 0, 2**c -1 downto 0 ) OF std_logic;
signal matrice_mem : matrice;



begin

Gen: for i in 1 to (2**c) generate
		
                   colonna_up_down_i : colonna_up_down
						 generic map (l,n)
						 port map (mux_in_sel, mux_out_sel,WE, clock, data_in ((i*((2**l)+1))-1 downto (i-1)*((2**l)+1)), CT_sel, ST_sel, MEM_out(i-1), colonne ((i)*((2**l)+1)-1 downto (i-1)*((2**l)+1) ));

end generate Gen;




 Gen1: for j in 0 to (2**l)  generate

		    Gen2:  for i in 0 to 2**c-1 generate
		  
               matrice_mem(j,i) <= colonne((i)*(2**l+1)+ j);
					
			 end generate Gen2;
		
                  
end generate Gen1;


end Behavioral;




