library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;


ENTITY Switch_T IS


 GENERIC (k : POSITIVE :=2 ; n : integer :=4);

	PORT( ST_sel :  in std_logic_vector(k*integer(ceil(log2(real(k))))-1 downto 0);
		   ST_in:    in std_logic_vector(n-1 downto 0);
		   ST_out:   out std_logic_vector(n-1 downto 0));
END Switch_T;


architecture behavioral of Switch_T is

component mux_Nto1 is

 	 GENERIC (n : POSITIVE :=2);
	 
    Port ( SEL : in  STD_LOGIC_VECTOR(integer(ceil(log2(real(n))))-1 downto 0);
           A   : in  STD_LOGIC_VECTOR(n-1 downto 0);
           X   : out STD_LOGIC);
end component mux_Nto1;




begin

Gen: for i in 0 to n-1 generate

      Gen_1 : if i <= k-1 generate
		
                   mux_Nto1_i : mux_Nto1 
						 generic map (k)
						 port map (ST_sel(((i+1)*integer(ceil(log2(real(k)))))-1 downto i*integer(ceil(log2(real(k))))),ST_in(k-1 downto 0),ST_out(i));				  
	   
		end generate Gen_1;
	  
      Gen_2 : if i >= k generate
		
                 	 ST_out(i)<= ST_in(i); 
						 
		end generate Gen_2;
	  			 
end generate Gen;

end Behavioral;
