library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


ENTITY Up_Down_A IS
 GENERIC (l : integer := 3; n : integer :=3);

	PORT( Cell_in    :  in std_logic_vector((2**l)-1 downto 0);
	      CT_sel     :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1  downto 0);
			ST_sel     :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
		   out_to_mux :  out std_logic_vector(indice_mux_in(2**l,n)-1 downto 0));
			
END Up_Down_A;


architecture behavioral of Up_Down_A is


component Control_T IS

	GENERIC (k : integer :=2 ; n : integer :=4);

	PORT( CT_sel :  in std_logic_vector(k-1 downto 0);
		   Cell_in:	 in std_logic;
		   CT_in:    in std_logic_vector(n-1 downto 0);
		   CT_out:   out std_logic_vector(n-1 downto 0));
			
END component Control_T;


component B_B IS


 GENERIC (k_ct : POSITIVE :=3 ; k_st : POSITIVE :=3 ; n : integer :=6);

	PORT( ST_sel :  in std_logic_vector(k_st*integer(ceil(log2(real(k_st))))-1 downto 0);
	      CT_sel :  in std_logic_vector(k_ct-1 downto 0);
		   B_B_in :  in std_logic_vector(n-1 downto 0);
			Cell_in:	 in std_logic;
		   B_B_out:  out std_logic_vector(n-1 downto 0));
			
END component B_B;


component B_0 is

 	 GENERIC (n : POSITIVE :=2);
	 
    Port ( Cell_in : in  STD_LOGIC;
           B_0_out : out  STD_LOGIC_VECTOR(n-1 downto 0));
 
end component B_0;


signal B_out: std_logic_vector(n*(2**l)-1 downto 0 );


begin


Gen: for i in 0 to (2**l)-1 generate

      ------------------------------------------------------------------------
		
		

      Gen_B0 : if i = 0 generate
		
                   B_0_0 : B_0 
						         generic map (n)	 
						         port map (Cell_in(i),B_out(n-1 downto i));	
				
                   out_to_mux(0) <= B_out(0);				
	   
		end generate Gen_B0;
		
		
		
		------------------------------------------------------------------------
		
	  
      Gen_BA : if i <= (2**l)-1 and i > 0 and (i mod 2) /= 0 generate
		
                 	   Control_T_i : Control_T  
						                 generic map (1, n)	 
	                                port map (CT_sel(indice_CT_sel(i,n)-1 downto indice_CT_sel(i,n)-1), Cell_in(i), B_out( ((i*n)-1) downto (i-1)*n ), B_out(((i+1)*n)-1 downto i*n ));
						 
		
                     out_to_mux(indice_mux_in(i+1,n)-1 downto indice_mux_in(i+1,n)-calcolo_k(i+1,n)) <= B_out(((i*n)+calcolo_k(i+1,n)-1) downto i*n);			
		
		end generate Gen_BA;
		
		
		------------------------------------------------------------------------
		
		
		Gen_BB : if i <= (2**l)-1 and i > 0 and (i mod 2) = 0 generate
		
                 	   B_B_i : B_B  
						           generic map (calcolo_k(i,n), calcolo_k(i,n), n)	 
	                          port map (ST_sel(indice_ST_sel(i,n)-1 downto indice_ST_sel(i,n)-calcolo_k(i,n)*integer(ceil(log2(real(calcolo_k(i,n)))))), CT_sel(indice_CT_sel(i,n)-1 downto indice_CT_sel(i,n)-calcolo_k(i,n)), B_out(((i*n)-1) downto (i-1)*n ),  Cell_in(i), B_out(((i+1)*n)-1 downto i*n));
											  					 
	
                     out_to_mux(indice_mux_in(i+1,n)-1 downto indice_mux_in(i+1,n)-calcolo_k(i+1,n)) <= B_out(((i*n)+calcolo_k(i+1,n)-1) downto i*n);								
		

    	end generate Gen_BB;
		
		
		
		-------------------------------------------------------------------------
		
		
end generate Gen;

end Behavioral;


