library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


ENTITY cell_mux_in_A IS
 GENERIC (l : integer := 2; n : integer :=2);

	PORT( mux_in   :  in std_logic_vector(indice_mux_in(2**l,n)-1 downto 0);
	      mux_sel  :  in std_logic_vector(indice_mux_sel(2**l,n)-1 downto 0);
			WE       :  in std_logic_vector((2**l) downto 0);
			clock    :  in std_logic;
			data_in  :  in std_logic_vector((2**l) downto 0);
		   cell_out :  out std_logic_vector((2**l)  downto 0);
			out_mux  :  out std_logic);
			
END cell_mux_in_A;



architecture behavioral of cell_mux_in_A is


component M_Cell IS

          PORT ( WE, Cell_in , clk : IN STD_LOGIC ;
                          Cell_out : OUT STD_LOGIC ) ;
END component M_Cell ;


component mux_Nto1_v2 is

 	 GENERIC (n : POSITIVE :=2);
	 
    Port ( SEL : in  STD_LOGIC_VECTOR(integer(ceil(log2(real(n))))-1 downto 0);
           A   : in  STD_LOGIC_VECTOR(n-2 downto 0);
			  B   : in  STD_LOGIC;
           X   : out STD_LOGIC);
end component;

signal mux_out: std_logic_vector((2**l)-1 downto 0);


begin


Gen: for i in 0 to (2**l) generate

      ------------------------------------------------------------------------
		
		

      Gen_B0 : if i = 0 generate
		
                   M_Cell_0 : M_Cell  
						            port map (WE(i),data_in(i),clock,cell_out(i));					 
	   
		end generate Gen_B0;
		
		
		
		------------------------------------------------------------------------
		
	  
      Gen_d : if i <= (2**l) and i > 0 and (i mod 2) /= 0 generate
		
                 	   mux_Nto1_i : mux_Nto1_v2  
						                generic map (2)	 
	                               port map ( mux_sel(indice_mux_sel(i,n)-1 downto indice_mux_sel(i,n)-integer(ceil(log2(real(calcolo_k_mux_in(i,n)))))), 
															mux_in(indice_mux_in(i,n)-1 downto indice_mux_in(i,n)-1),
															data_in(i),
															mux_out(i-1));
											
							M_Cell_i   : M_Cell  
						                port map (WE(i), mux_out(i-1),clock,cell_out(i));	
						 
		end generate Gen_d;
		
		
		------------------------------------------------------------------------
		
	  
      Gen_p : if i <= (2**l) and i > 0 and (i mod 2) = 0 generate
		
                 	   mux_Nto1_i : mux_Nto1_v2  
						                generic map (calcolo_k_mux_in(i,n))	 
	                               port map (  mux_sel(indice_mux_sel(i,n)-1 downto indice_mux_sel(i,n)-integer(ceil(log2(real(calcolo_k_mux_in(i,n)))))), 
															 mux_in(indice_mux_in(i,n)-1 downto indice_mux_in(i,n)- calcolo_k(i,n)),
															 data_in(i),
														    mux_out(i-1));
											
							M_Cell_i   : M_Cell  
						                port map (WE(i), mux_out(i-1),clock,cell_out(i));	
						 
		end generate Gen_p;
		
		
	
end generate Gen;


out_mux <= mux_out((2**l)-1) ;


end Behavioral;




		









