library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


ENTITY cell_mux_in_A_bid IS
 GENERIC (l : integer := 3; n : integer :=3);

	PORT( mux_in      :  in std_logic_vector(indice_mux_in(2**l,n)-1 downto 0);
	      mux_sel     :  in std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0);
			mux_in_up   :  in std_logic_vector(indice_mux_in(2**l,n)-1 downto 0);
	      mux_sel_up  :  in std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0);			
			WE          :  in std_logic_vector((2**l) downto 0);
			clock       :  in std_logic;
			data_in     :  in std_logic_vector((2**l) downto 0);	
		   data_or_sel :  in std_logic_vector((2**l) downto 0);	
	      up_down_sel :  in std_logic_vector((2**l)-2 downto 0);		
		   cell_out    :  out std_logic_vector((2**l)  downto 0);
			out_mux_down:  out std_logic;
			out_mux_up  :  out std_logic);
			
END cell_mux_in_A_bid;



architecture behavioral of cell_mux_in_A_bid is


component M_Cell IS

          PORT ( WE, Cell_in , clk : IN STD_LOGIC ;
                          Cell_out : OUT STD_LOGIC ) ;
END component M_Cell ;


component mux_Nto1 is

 	 GENERIC (n : POSITIVE :=2);
	 
    Port ( SEL : in  STD_LOGIC_VECTOR(integer(ceil(log2(real(n))))-1 downto 0);
           A   : in  STD_LOGIC_VECTOR(n-1 downto 0);
           X   : out STD_LOGIC);
end component mux_Nto1;


component mux_2to1 is
    Port ( SEL : in  STD_LOGIC;
           A   : in  STD_LOGIC;
           B   : in  STD_LOGIC;
           X   : out STD_LOGIC);
end component;


signal mux_out_down: std_logic_vector((2**l)-1 downto 0);
signal mux_out_up: std_logic_vector((2**l)-1 downto 0);
signal mux_out: std_logic_vector((2**l) downto 0);
signal mux_up_down_out: std_logic_vector((2**l)-2 downto 0);


begin




Gen: for i in 0 to (2**l) generate

      ------------------------------------------------------------------------
		
		

      Gen_B0 : if i = 0 generate
		
		          mux_up_Nto1_i :      mux_Nto1  
						                   generic map (calcolo_k((2**l)-i,n))
												 
	                                  port map ( mux_sel_up(indice_mux_sel_bid((2**l)-i,n)-1 downto indice_mux_sel_bid((2**l)-i,n)-integer(ceil(log2(real(calcolo_k((2**l)-i,n)))))), 
															   mux_in_up(indice_mux_in((2**l)-i,n)-1 downto indice_mux_in((2**l)-i,n)- calcolo_k((2**l)-i,n)),
															   mux_out_up((2**l)-i-1));
		
		
		         mux_datin_or   :     mux_2to1 
					
	                                    port map (  data_or_sel(i), 
															      data_in(i),
															      mux_out_up((2**l)-i-1),
															      mux_out(i));
		
                   M_Cell_0 : M_Cell  
						            port map (WE(i), mux_out(i),clock, cell_out(i));					 
	   
		end generate Gen_B0;
		
		
		
		------------------------------------------------------------------------
		
		
	  
      Gen_p : if i < (2**l) and i > 0 generate
		
                 	   mux_Nto1_i : mux_Nto1  
						                generic map (calcolo_k(i,n))	 
	                               port map (  mux_sel(indice_mux_sel_bid(i,n)-1 downto indice_mux_sel_bid(i,n)-integer(ceil(log2(real(calcolo_k(i,n)))))), 
															 mux_in(indice_mux_in(i,n)-1 downto indice_mux_in(i,n)- calcolo_k(i,n)),
															 mux_out_down(i-1));
															 
															 
							mux_up_Nto1_i :      mux_Nto1  
						                   generic map (calcolo_k((2**l)-i,n))
												 
	                                  port map ( mux_sel_up(indice_mux_sel_bid((2**l)-i,n)-1 downto indice_mux_sel_bid((2**l)-i,n)-integer(ceil(log2(real(calcolo_k((2**l)-i,n)))))), 
															   mux_in_up(indice_mux_in((2**l)-i,n)-1 downto indice_mux_in((2**l)-i,n)- calcolo_k((2**l)-i,n)),
															   mux_out_up((2**l)-i-1));
							
							mux_up_down_out_i :   mux_2to1  
						                  	 
	                                    port map (up_down_sel(i-1), 
															    mux_out_down(i-1),
															    mux_out_up((2**l)-i-1),
															    mux_up_down_out(i-1));
																 
								
							mux_datin_or :    mux_2to1  
						                	 
	                                    port map ( data_or_sel(i), 
															    data_in(i),
															    mux_out_up((2**l)-i-1),
															    mux_out(i));
															 
															 
											
							M_Cell_i   : M_Cell  
						                port map (WE(i), mux_out(i),clock,cell_out(i));	
						 
		end generate Gen_p;
		
		
		------------------------------------------------------------------------		

	  
      Gen_d : if i = (2**l) generate
		

		               mux_Nto1_i : mux_Nto1  
						                generic map (calcolo_k(i,n))	 
	                               port map (  mux_sel(indice_mux_sel_bid(i,n)-1 downto indice_mux_sel_bid(i,n)-integer(ceil(log2(real(calcolo_k(i,n)))))), 
															 mux_in(indice_mux_in(i,n)-1 downto indice_mux_in(i,n)- calcolo_k(i,n)),
															 mux_out_down(i-1));
	
		  
		               mux_datin_or   :   mux_2to1 
	                                     port map ( data_or_sel(i), 
															      data_in(i),
															      mux_out_down(i-1),
															      mux_out(i));
															 
											
							M_Cell_i   : M_Cell  
						                port map (WE(i), mux_out(i),clock,cell_out(i));	
						 
		end generate Gen_d;
		
		
		------------------------------------------------------------------------
		
		
	
end generate Gen;



out_mux_down <= mux_out_down ((2**l)-1) ;
out_mux_up   <= mux_out_up   ((2**l)-1) ;


end Behavioral;

