library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;



ENTITY colonna_bid IS
 GENERIC (l : integer := 3; n : integer :=3);

	PORT( mux_in_sel_down     :  in std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0);
	      mux_in_sel_up       :  in std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0);
			WE                  :  in std_logic_vector((2**l) downto 0);
			clock               :  in std_logic;
			data_in             :  in std_logic_vector((2**l) downto 0);
			data_or_outmux_sel  :  in std_logic_vector((2**l) downto 0);	
			up_down_sel         :  in std_logic_vector((2**l)-2 downto 0);	
			colonna_out_down    :  out std_logic;
			colonna_out_up      :  out std_logic;			
	      mux_outcol_sel_up   :  in std_logic;
		   mux_outcol_sel_down :  in std_logic;
			CT_sel_up           :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1 downto 0);
			ST_sel_up           :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);		
			CT_sel_down         :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1 downto 0);
			ST_sel_down         :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
			contenuto_celle     : out std_logic_vector((2**l)  downto 0));
			
END colonna_bid;



architecture behavioral of colonna_bid is


component cell_mux_in_A_bid IS
 GENERIC (l : integer := 3; n : integer :=3);

	PORT( mux_in      :  in std_logic_vector(indice_mux_in(2**l,n)-1 downto 0);
	      mux_sel     :  in std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0);
			mux_in_up   :  in std_logic_vector(indice_mux_in(2**l,n)-1 downto 0);
	      mux_sel_up  :  in std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0);			
			WE          :  in std_logic_vector((2**l) downto 0);
			clock       :  in std_logic;
			data_in     :  in std_logic_vector((2**l) downto 0);	
		   data_or_sel :  in std_logic_vector((2**l) downto 0);	
	      up_down_sel :  in std_logic_vector((2**l)-2 downto 0);		
		   cell_out    :  out std_logic_vector((2**l)  downto 0);
			out_mux_down:  out std_logic;
			out_mux_up  :  out std_logic);
			
END component cell_mux_in_A_bid;


component Up_Down_A IS
 GENERIC (l : integer := 3; n : integer :=3);

	PORT( Cell_in    :  in std_logic_vector((2**l)-1 downto 0);
	      CT_sel     :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1 downto 0);
			ST_sel     :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
			out_to_mux :  out std_logic_vector(indice_mux_in(2**l,n)-1 downto 0));
			
END component Up_Down_A;


component mux_2to1 is
    Port ( SEL : in  STD_LOGIC;
           A   : in  STD_LOGIC;
           B   : in  STD_LOGIC;
           X   : out STD_LOGIC);
end component mux_2to1;


signal X_up    : std_logic_vector(indice_mux_in(2**l,n)-1 downto 0);
signal X_down  : std_logic_vector(indice_mux_in(2**l,n)-1 downto 0);

signal y   : std_logic_vector((2**l)  downto 0);
signal y_c : std_logic_vector((2**l)  downto 0);

signal out_mux_down_c  : std_logic;
signal out_mux_up_c  : std_logic;



begin

A:   cell_mux_in_A_bid
     generic map(l,n)
	  port map(X_down, mux_in_sel_down, X_up, mux_in_sel_up, WE, clock, data_in, data_or_outmux_sel, up_down_sel, y, out_mux_down_c, out_mux_up_c);

	 
B_down:  Up_Down_A
     generic map(l,n)
	  port map( y((2**l)-1 downto 0), 
	            CT_sel_down, 
					ST_sel_down, 
					X_down);
					

	 
					
Gen: for i in 1 to (2**l) generate

		y_c((2**l)-i)<=y(i);
               
end generate Gen;


B_up  :  Up_Down_A
      generic map(l,n)
	   port map(y_c((2**l)-1 downto 0), 
			      CT_sel_up, 
					ST_sel_up, 
					X_up);
							
	 
	 
M_down:  mux_2to1 
         port map(mux_outcol_sel_down, y(2**l), out_mux_down_c, colonna_out_down);
	  
	 
M_up:  mux_2to1 
       port map(mux_outcol_sel_up, y(0), out_mux_up_c , colonna_out_up);
	 
contenuto_celle <= y;

end Behavioral;

