library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;



ENTITY colonna_up_down IS
 GENERIC (l : integer := 3; n : integer :=3);

	PORT( mux_in_sel  :  in std_logic_vector(indice_mux_sel(2**l,n)-1 downto 0);
	      mux_out_sel :  in std_logic;
			WE          :  in std_logic_vector((2**l) downto 0);
			clock       :  in std_logic;
			data_in     :  in std_logic_vector((2**l) downto 0);
			CT_sel      :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1 downto 0);
			ST_sel      :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
		   colonna_out :  out std_logic;
			contenuto_celle: out std_logic_vector((2**l)  downto 0));
			
END colonna_up_down;



architecture behavioral of colonna_up_down is



component cell_mux_in_A IS
 GENERIC (l : integer := 3; n : integer :=3);

	PORT( mux_in   :  in std_logic_vector(indice_mux_in(2**l,n)-1 downto 0);
	      mux_sel  :  in std_logic_vector(indice_mux_sel(2**l,n)-1 downto 0);
			WE       :  in std_logic_vector((2**l) downto 0);
			clock    :  in std_logic;
			data_in  :  in std_logic_vector((2**l) downto 0);
		   cell_out :  out std_logic_vector((2**l)  downto 0);
			out_mux  :  out std_logic);
			
END component cell_mux_in_A;

component Up_Down_A IS
 GENERIC (l : integer := 3; n : integer :=3);

	PORT( Cell_in    :  in std_logic_vector((2**l)-1 downto 0);
	      CT_sel     :  in std_logic_vector(indice_CT_sel((2**l)-1,n)-1 downto 0);
			ST_sel     :  in std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
			out_to_mux :  out std_logic_vector(indice_mux_in(2**l,n)-1 downto 0));
			
END component Up_Down_A;


component mux_2to1 is
    Port ( SEL : in  STD_LOGIC;
           A   : in  STD_LOGIC;
           B   : in  STD_LOGIC;
           X   : out STD_LOGIC);
end component mux_2to1;


signal X: std_logic_vector(indice_mux_in(2**l,n)-1 downto 0);
signal y: std_logic_vector((2**l)  downto 0);
signal out_mux_c  : std_logic;



begin

A:  cell_mux_in_A
    generic map(l,n)
	 port map(x, mux_in_sel, WE, clock, data_in, y, out_mux_c);

B:  Up_Down_A
    generic map(l,n)
	 port map(y((2**l)-1 downto 0), CT_sel, ST_sel, x);
	 
M:  mux_2to1 
    port map(mux_out_sel, y(2**l), out_mux_c, colonna_out);
	 
contenuto_celle <= y;
	 
end Behavioral;



