library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


entity gen_vettori_CT_e_ST_sel_Singola_move is 

	generic (l	: integer := 3 ; n : POSITIVE :=3 ; X : integer :=4);	
	
	port ( all_Address    : in std_logic_vector ((X-1)*l-1 downto 0);
		    vettore_I      : in std_logic_vector (X*integer(ceil(log2(real(n+1))))-1 downto 0);
			 vettore_CT_sel : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0);
			 vettore_ST_sel : out std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0));
				
end gen_vettori_CT_e_ST_sel_Singola_move;


architecture behavioral of gen_vettori_CT_e_ST_sel_Singola_move is


component decoder is 

	generic (l	: integer := 5);	
	
	port ( address:   in std_logic_vector (l-1 downto 0);	
		    dec_out: 	out std_logic_vector (2**l-1 downto 0));
				
end component;



component vettore_ST_sel_Singola_move is 

	generic (l	: integer := 3 ; n : POSITIVE :=3 ; X : integer :=4);	
	
	port ( Address        : in std_logic_vector ((X-1)*(2**l)-1 downto 0);
		    vettore_I      : in std_logic_vector (X*integer(ceil(log2(real(n+1))))-1 downto 0);
			 vettore_ST_sel : out std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0));
				
end component;



component vettore_CT_sel_Singola_move is 

	generic (l	: integer := 3 ; n : POSITIVE :=3 ; X : integer :=4);	
	
	port ( Address        : in std_logic_vector ((X-1)*(2**l)-1 downto 0);
		    vettore_I      : in std_logic_vector ((X-1)*integer(ceil(log2(real(n+1))))-1 downto 0);
			 vettore_CT_sel : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0));
				
end component;


signal dec_out   : std_logic_vector ((X-1)*(2**l)-1 downto 0);



begin 


Gen: for i in 0 to (X-2) generate

										 										 											 
										 
	        decoder_i                : decoder
			                             generic map (l)
										        port map (all_Address((i+1)*l-1 downto i*l), 
												            dec_out((i+1)*(2**l)-1 downto i*(2**l)));
										 
										 
end generate Gen;	


vettore_CT_sel_Singola_move_1 : vettore_CT_sel_Singola_move
                                generic map (l,n,x)
						              port map (dec_out, 
										            vettore_I(X*integer(ceil(log2(real(n+1))))-1 downto integer(ceil(log2(real(n+1))))),
														vettore_CT_sel);
														

vettore_ST_sel_Singola_move_1 : vettore_ST_sel_Singola_move
                                generic map (l,n,x)
						              port map (dec_out, 
										            vettore_I(X*integer(ceil(log2(real(n+1))))-1 downto 0),
														vettore_ST_sel);
								  
end behavioral;
						 
						