library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;

entity generatore_ST_selp is 

	generic (n	: POSITIVE  := 4);	
	
	port ( I_i:	      in std_logic_vector (integer(ceil(log2(real(n+1))))-1 downto 0);
	
	       I_i_meno_1:in std_logic_vector (integer(ceil(log2(real(n+1))))-1 downto 0);
		
		    ST_sel: 	out std_logic_vector (grandezza_gen_ST_out(n)-1 downto 0));
				
end generatore_ST_selp;


architecture behavioral of generatore_ST_selp is


component generatore_ST_sel2 is 

	generic (n	: POSITIVE  := 3 ; k	: POSITIVE  := 2);
	
	port ( I_i:	      in std_logic_vector (integer(ceil(log2(real(n+1))))-1 downto 0);
	       I_i_meno_1:in std_logic_vector (integer(ceil(log2(real(n+1))))-1 downto 0);
		    ST_sel: 	out std_logic_vector (k*integer(ceil(log2(real(k))))-1 downto 0));
				
end component;


signal ST_sel_c: std_logic_vector (grandezza_gen_ST_out(n)-1 downto 0);


begin


Gen: for k in 2 to n generate

     generatore_ST_sel_k: generatore_ST_sel2
	                       generic map(n,k)
								  port map (I_i, I_i_meno_1, ST_sel_c(grandezza_gen_ST_out(k)-1 downto grandezza_gen_ST_out(k)-k*integer(ceil(log2(real(k))))));
								  
end generate Gen;

ST_sel <= ST_sel_c;

	
end behavioral;