library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


entity generazione_segnali_controllo_RAM_bidirezionale_Singola_move is 

	generic (l	: integer := 3 ; n : POSITIVE :=3 ; X : integer :=4);	
	
	port ( Start_Address  : in std_logic_vector (l-1 downto 0);
		    vettore_I      : in std_logic_vector (X*integer(ceil(log2(real(n+1))))-1 downto 0);
			 vettore_WE     : out std_logic_vector(2**l-1 downto 0);
			 vettore_CT_sel : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0);
			 vettore_ST_sel : out std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
			 muxin_sel_out  : out std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0);
			 Start_address_dec: out std_logic_vector (2**l-1 downto 0));
				
end generazione_segnali_controllo_RAM_bidirezionale_Singola_move;


architecture behavioral of generazione_segnali_controllo_RAM_bidirezionale_Singola_move is



component decoder is 

	generic (l	: integer := 5);	
	
	port ( address:   in std_logic_vector (l-1 downto 0);	
		    dec_out: 	out std_logic_vector (2**l-1 downto 0));
				
end component;



component Adder_Add_multiple_I is 

	generic (l : POSITIVE :=5 ; n : integer :=3 ; i : integer :=3);
	
	port ( Address        : in std_logic_vector (l-1 downto 0);	
	       Incremento     : in std_logic_vector (i*n-1 downto 0);		
		    Sum            : out std_logic_vector (i*l-1 downto 0));
				
end component;



component decodificatore_I is 

	generic (n : POSITIVE :=5 ; X : integer :=4);	
	port ( Vettore_I         : in  std_logic_vector (X*integer(ceil(log2(real(n+1))))-1 downto 0);
			 Vettore_I_dec     : out std_logic_vector (X*n-1 downto 0));			
			
end component;



component gen_vettori_CT_e_ST_sel_Singola_move is 

	generic (l	: integer := 3 ; n : POSITIVE :=3 ; X : integer :=4);	
	port ( all_Address    : in std_logic_vector ((X-1)*l-1 downto 0);
		    vettore_I      : in std_logic_vector (X*integer(ceil(log2(real(n+1))))-1 downto 0);
			 vettore_CT_sel : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0);
			 vettore_ST_sel : out std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0));
				
end component;



component ultimo_I_no_0 is 

	generic (n : POSITIVE :=4 ; X : integer :=4);	
	
	port ( vettore_I  : in std_logic_vector (X*integer(ceil(log2(real(n+1))))-1 downto 0);
			 I_out      : out std_logic_vector(integer(ceil(log2(real(n))))-1 downto 0));
				
end component ;


component And_gen_muxin_sel_bidirezionale is 

	generic (l: integer := 4 ; n: integer := 4);	
	
	port ( dec_add           : in std_logic_vector(2**l -1 downto 0);
		    singolo_muxin_sel : in std_logic_vector(integer(ceil(log2(real(n))))-1 downto 0);
			 muxin_sel_out     : out std_logic_vector(indice_mux_sel_bid(2**l,n)-1 downto 0));
				
end component;



signal Vettore_I_dec  : std_logic_vector (X*n-1 downto 0);
signal I_out          : std_logic_vector(integer(ceil(log2(real(n))))-1 downto 0);
signal sum_c          : std_logic_vector(x*l-1 downto 0);
signal vettore_WE_copy: std_logic_vector(2**l-1 downto 0);



begin 


           decodificatore_I_1       : decodificatore_I
                                      generic map (n,x)	
											     port map (vettore_I,
												            vettore_I_dec
											               );
										 			
													
													
																				
			  Adder_Add_multiple_I_i   : Adder_Add_multiple_I
                                      generic map (l,n,x)	
											     port map (Start_Address,
												            vettore_I_dec,
											               sum_c);
										 			
										 
										 
	        decoder_i                : decoder
			                             generic map (l)
										        port map (sum_c(x*l-1 downto (x-1)*l), 
												            vettore_WE_copy);
																
			  
			  decoder_s_address        : decoder
			                             generic map (l)
										        port map (Start_Address, 
												            Start_address_dec);
																
																
							 			
           										 
			  gen_vettori_CT_e_ST_sel_Singola_move_1   : gen_vettori_CT_e_ST_sel_Singola_move
                                      generic map (l,n,x)	
											     port map (sum_c((x-1)*l-1 downto 0),
												            vettore_I,
																vettore_CT_sel,
											               vettore_ST_sel);
										 			
										 
																
			  ultimo_I_no_0_1                : ultimo_I_no_0
			                                                  generic map (n,x)
										                             port map (vettore_I, 
												                                 I_out);
																
																
			 And_gen_muxin_sel_1            : And_gen_muxin_sel_bidirezionale
			                             generic map (l,n)
										        port map (vettore_WE_copy, 
												            I_out,
																muxin_sel_out);
																
																

			vettore_WE <= vettore_WE_copy;

end behavioral;
						 