library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


entity generazione_segnali_controllo_RAM_unidirezionale_multiple_move is 

	generic (l	: integer := 3 ; n : POSITIVE :=3 ; X : integer :=4 ; M : integer :=3);	
	
	port ( Start_Address  : in std_logic_vector (M*l-1 downto 0);
		    vettore_I      : in std_logic_vector (M*X*integer(ceil(log2(real(n+1))))-1 downto 0);
			 vettore_WE     : out std_logic_vector(2**l-1 downto 0);
			 vettore_CT_sel : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0);
			 vettore_ST_sel : out std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
			 muxin_sel_out  : out std_logic_vector(indice_mux_sel(2**l,n)-1 downto 0));
				
end generazione_segnali_controllo_RAM_unidirezionale_multiple_move;


architecture behavioral of generazione_segnali_controllo_RAM_unidirezionale_multiple_move is



component generazione_segnali_controllo_RAM_unidirezionale_Singola_move is 

	generic (l	: integer := 3 ; n : POSITIVE :=3 ; X : integer :=4);	
	
	port ( Start_Address  : in std_logic_vector (l-1 downto 0);
		    vettore_I      : in std_logic_vector (X*integer(ceil(log2(real(n+1))))-1 downto 0);
			 vettore_WE     : out std_logic_vector(2**l-1 downto 0);
			 vettore_CT_sel : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0);
			 vettore_ST_sel : out std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0);
			 muxin_sel_out  : out std_logic_vector(indice_mux_sel(2**l,n)-1 downto 0));
				
end component;


component OR_2_generic_input is 

	generic (num_in: integer := 3);	
	
	port ( in_1     : in std_logic_vector(num_in-1 downto 0);
	       in_2     : in std_logic_vector(num_in-1 downto 0);
			 or_out   : out std_logic_vector(num_in-1 downto 0));
				
end component;



signal          vettore_WE_c     : std_logic_vector(M*(2**l)-1 downto 0);
signal			 vettore_CT_sel_c : std_logic_vector(M*(indice_CT_sel((2**l)-1,n)-1)-1 downto 0);
signal			 vettore_ST_sel_c : std_logic_vector(M*grandezza_ST_sel(l,n)-1 downto 0);
signal			 muxin_sel_out_c  : std_logic_vector(M*indice_mux_sel(2**l,n)-1 downto 0);

signal          vettore_WE_c2     : std_logic_vector((M-1)*(2**l)-1 downto 0);
signal			 vettore_CT_sel_c2 : std_logic_vector((M-1)*(indice_CT_sel((2**l)-1,n)-1)-1 downto 0);
signal			 vettore_ST_sel_c2 : std_logic_vector((M-1)*grandezza_ST_sel(l,n)-1 downto 0);
signal			 muxin_sel_out_c2  : std_logic_vector((M-1)*indice_mux_sel(2**l,n)-1 downto 0);


begin 


Gen: for i in 0 to (M-1) generate



 Gen_0 : if i = 0 generate									 										 											 
										 
 gen_S_i         : generazione_segnali_controllo_RAM_unidirezionale_Singola_move
                                      generic map (l,n,x)	
											     port map (  Start_Address( (i+1)*l -1 downto i*l ),
		                                            vettore_I( (i+1)*X*integer(ceil(log2(real(n+1)))) -1 downto i*X*integer(ceil(log2(real(n+1)))) ),
			                                         vettore_WE_c( (i+1)*(2**l) -1 downto i*(2**l) ),    
			                                         vettore_CT_sel_c( (i+1)* (indice_CT_sel((2**l)-1,n)-1) -1 downto i* (indice_CT_sel((2**l)-1,n)-1) ),
			                                         vettore_ST_sel_c( (i+1)*grandezza_ST_sel(l,n) -1 downto i*grandezza_ST_sel(l,n) ), 
			                                         muxin_sel_out_c ( (i+1)*indice_mux_sel(2**l,n) -1 downto i*indice_mux_sel(2**l,n) )); 

																  
end generate Gen_0;																  
																  
 Gen_1 : if i = 1 generate								
							
		
 gen_S2_i         : generazione_segnali_controllo_RAM_unidirezionale_Singola_move
                                      generic map (l,n,x)	
											     port map (  Start_Address( (i+1)*l -1 downto i*l ),
		                                            vettore_I( (i+1)*X*integer(ceil(log2(real(n+1)))) -1 downto i*X*integer(ceil(log2(real(n+1)))) ),
			                                         vettore_WE_c( (i+1)*(2**l) -1 downto i*(2**l) ),    
			                                         vettore_CT_sel_c( (i+1)* (indice_CT_sel((2**l)-1,n)-1) -1 downto i* (indice_CT_sel((2**l)-1,n)-1) ),
			                                         vettore_ST_sel_c( (i+1)*grandezza_ST_sel(l,n) -1 downto i*grandezza_ST_sel(l,n) ), 
			                                         muxin_sel_out_c ( (i+1)*indice_mux_sel(2**l,n) -1 downto i*indice_mux_sel(2**l,n) )); 
																  
or_i_WE          : OR_2_generic_input
                                      generic map (2**l)	
											     port map (vettore_WE_c( (i+1)*(2**l) -1 downto i*(2**l) ),
												            vettore_WE_c( (i)*(2**l) -1 downto (i-1)*(2**l) ),
											               vettore_WE_c2( (i)*(2**l) -1 downto (i-1)*(2**l) ));															  

																
																
or_i_CT          : OR_2_generic_input
                                      generic map (indice_CT_sel((2**l)-1,n)-1)	
											     port map (vettore_CT_sel_c( (i+1)* (indice_CT_sel((2**l)-1,n)-1) -1 downto i* (indice_CT_sel((2**l)-1,n)-1) ),
												            vettore_CT_sel_c( (i)* (indice_CT_sel((2**l)-1,n)-1) -1 downto (i-1)* (indice_CT_sel((2**l)-1,n)-1) ),
											               vettore_CT_sel_c2( (i)* (indice_CT_sel((2**l)-1,n)-1) -1 downto (i-1)* (indice_CT_sel((2**l)-1,n)-1) ));	
																
																
or_i_ST          : OR_2_generic_input
                                      generic map (grandezza_ST_sel(l,n))	
											     port map (vettore_ST_sel_c( (i+1)*grandezza_ST_sel(l,n) -1 downto i*grandezza_ST_sel(l,n) ),
												            vettore_ST_sel_c( (i)*grandezza_ST_sel(l,n) -1 downto (i-1)*grandezza_ST_sel(l,n) ),
											               vettore_ST_sel_c2( (i)*grandezza_ST_sel(l,n) -1 downto (i-1)*grandezza_ST_sel(l,n) ));															  

																
																
or_i_muxsel      : OR_2_generic_input
                                      generic map (indice_mux_sel(2**l,n))	
											     port map ( muxin_sel_out_c ( (i+1)*indice_mux_sel(2**l,n) -1 downto i*indice_mux_sel(2**l,n) ),
												             muxin_sel_out_c ( i*indice_mux_sel(2**l,n) -1 downto (i-1)*indice_mux_sel(2**l,n) ),
											                muxin_sel_out_c2 ( i*indice_mux_sel(2**l,n) -1 downto (i-1)*indice_mux_sel(2**l,n) ));	

end generate Gen_1;	



																  
 Gen_2 : if i > 1 generate								
							
		
 gen_S2_i         : generazione_segnali_controllo_RAM_unidirezionale_Singola_move
                                      generic map (l,n,x)	
											     port map (  Start_Address( (i+1)*l -1 downto i*l ),
		                                            vettore_I( (i+1)*X*integer(ceil(log2(real(n+1)))) -1 downto i*X*integer(ceil(log2(real(n+1)))) ),
			                                         vettore_WE_c( (i+1)*(2**l) -1 downto i*(2**l) ),    
			                                         vettore_CT_sel_c( (i+1)* (indice_CT_sel((2**l)-1,n)-1) -1 downto i* (indice_CT_sel((2**l)-1,n)-1) ),
			                                         vettore_ST_sel_c( (i+1)*grandezza_ST_sel(l,n) -1 downto i*grandezza_ST_sel(l,n) ), 
			                                         muxin_sel_out_c ( (i+1)*indice_mux_sel(2**l,n) -1 downto i*indice_mux_sel(2**l,n) )); 
																  
or_i_WE          : OR_2_generic_input
                                      generic map (2**l)	
											     port map (vettore_WE_c( (i+1)*(2**l) -1 downto i*(2**l) ),
												            vettore_WE_c2( (i-1)*(2**l) -1 downto (i-2)*(2**l) ),
											               vettore_WE_c2( (i)*(2**l) -1 downto (i-1)*(2**l) ));															  

																
																
or_i_CT          : OR_2_generic_input
                                      generic map (indice_CT_sel((2**l)-1,n)-1)	
											     port map (vettore_CT_sel_c( (i+1)* (indice_CT_sel((2**l)-1,n)-1) -1 downto i* (indice_CT_sel((2**l)-1,n)-1) ),
												            vettore_CT_sel_c2( (i-1)* (indice_CT_sel((2**l)-1,n)-1) -1 downto (i-2)* (indice_CT_sel((2**l)-1,n)-1) ),
											               vettore_CT_sel_c2( (i)* (indice_CT_sel((2**l)-1,n)-1) -1 downto (i-1)* (indice_CT_sel((2**l)-1,n)-1) ));	
																
																
or_i_ST          : OR_2_generic_input
                                      generic map (grandezza_ST_sel(l,n))	
											     port map (vettore_ST_sel_c( (i+1)*grandezza_ST_sel(l,n) -1 downto i*grandezza_ST_sel(l,n) ),
												            vettore_ST_sel_c2( (i-1)*grandezza_ST_sel(l,n) -1 downto (i-2)*grandezza_ST_sel(l,n) ),
											               vettore_ST_sel_c2( (i)*grandezza_ST_sel(l,n) -1 downto (i-1)*grandezza_ST_sel(l,n) ));															  

																
																
or_i_muxsel      : OR_2_generic_input
                                      generic map (indice_mux_sel(2**l,n))	
											     port map ( muxin_sel_out_c ( (i+1)*indice_mux_sel(2**l,n) -1 downto i*indice_mux_sel(2**l,n) ),
												             muxin_sel_out_c2 ( (i-1)*indice_mux_sel(2**l,n) -1 downto (i-2)*indice_mux_sel(2**l,n) ),
											                muxin_sel_out_c2 ( i*indice_mux_sel(2**l,n) -1 downto (i-1)*indice_mux_sel(2**l,n) ));	

end generate Gen_2;	




	
end generate Gen;	






vettore_WE <= vettore_WE_c2((M-1)*(2**l)-1 downto (M-2)*(2**l));
vettore_CT_sel <= vettore_CT_sel_c2((M-1)*(indice_CT_sel((2**l)-1,n)-1)-1 downto (M-2)*(indice_CT_sel((2**l)-1,n)-1));
vettore_ST_sel <= vettore_ST_sel_c2((M-1)*grandezza_ST_sel(l,n)-1 downto (M-2)*grandezza_ST_sel(l,n));
muxin_sel_out	<= muxin_sel_out_c2((M-1)*indice_mux_sel(2**l,n)-1 downto (M-2)*indice_mux_sel(2**l,n));

end behavioral;