library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_unsigned.all;

entity mux_Nto1_v2 is

 	 GENERIC (n : POSITIVE :=2);
	 
    Port ( SEL : in  STD_LOGIC_VECTOR(integer(ceil(log2(real(n))))-1 downto 0);
           A   : in  STD_LOGIC_VECTOR(n-2 downto 0);
			  B   : in  STD_LOGIC;
           X   : out STD_LOGIC);
end mux_Nto1_v2;

architecture Behavioral of mux_Nto1_v2 is


begin

P0: process(sel,A,B)

	begin
	
	  if (to_integer(unsigned(SEL)) = 0) then

	    X <= B;
		 
	  else
		 
       X <= A(to_integer(unsigned(sel))-1);
		 
	  end if;

	end process;

end behavioral; 



  
		


