library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


--attenzione.  vettore_I va da I1 a Ix-1

entity vettore_CT_sel_Singola_move is 

	generic (l	: integer := 3 ; n : POSITIVE :=3 ; X : integer :=4);	
	
	port ( Address        : in std_logic_vector ((X-1)*(2**l)-1 downto 0);
		    vettore_I      : in std_logic_vector ((X-1)*integer(ceil(log2(real(n+1))))-1 downto 0);
			 vettore_CT_sel : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0));
				
end vettore_CT_sel_Singola_move;


architecture behavioral of vettore_CT_sel_Singola_move is


component generatore_CT_sel is 

	generic (n	: integer := 3);	
	
	port ( I_i   :	 in std_logic_vector (integer(ceil(log2(real(n+1))))-1 downto 0);	
		    CT_sel:  out std_logic_vector (n-1 downto 0));
				
end component generatore_CT_sel;


component And_gen_CT_sel is 

	generic (l: integer := 5 ; n: integer := 3);	
	
	port ( dec_add        : in std_logic_vector(2**l -3 downto 0);
		    singolo_CT_sel : in std_logic_vector (n-1 downto 0);
			 CT_vettore_out : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0));
				
end component And_gen_CT_sel;


component OR_tra_vettori_CT_sel is 

	generic (l: integer := 5 ; X: integer := 3 ; n: integer := 3);	
	
	port ( CT_in    : in std_logic_vector ((X-1)*(indice_CT_sel((2**l)-1,n)-1)-1 downto 0);
			 CT_out   : out std_logic_vector(indice_CT_sel((2**l)-1,n)-2 downto 0));
				
end component OR_tra_vettori_CT_sel;



signal CT_sel_c  : std_logic_vector (((X-1)*n)-1 downto 0);
signal out_c     : std_logic_vector ((X-1)*(indice_CT_sel((2**l)-1,n)-1)-1 downto 0);



begin 


Gen: for i in 0 to (X-2) generate

										 			
           										 
			  generatore_CT_sel_i    : generatore_CT_sel 
                                    generic map (n)	
											   port map (vettore_I((i+1)*integer(ceil(log2(real(n+1))))-1 downto i*integer(ceil(log2(real(n+1))))), CT_sel_c((i+1)*(n)-1 downto i*(n)));
										 			
										 
										 
			  And_gen_CT_sel_i       : And_gen_CT_sel
                                    generic map (l,n)	
												port map (address((i+1)*(2**l)-2 downto i*(2**l)+1), CT_sel_c((i+1)*(n)-1 downto i*(n)), out_c((i+1)*(indice_CT_sel((2**l)-1,n)-1)-1 downto i*(indice_CT_sel((2**l)-1,n)-1)));
										 
										 
end generate Gen;	


OR_tra_vettori_CT_sel_1 : OR_tra_vettori_CT_sel
                          generic map (l,X,n)
						        port map (out_c, vettore_CT_sel);
								  
end behavioral;
						 
										 
										 