library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.MATH_REAL.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
USE WORK.MY_PACKAGE.ALL;
USE WORK.MY_PACKAGE_2.ALL;


entity vettore_ST_sel_Singola_move is 

	generic (l	: integer := 3 ; n : POSITIVE :=3 ; X : integer :=4);	
	
	port ( Address        : in std_logic_vector ((X-1)*(2**l)-1 downto 0);
		    vettore_I      : in std_logic_vector (X*integer(ceil(log2(real(n+1))))-1 downto 0);
			 vettore_ST_sel : out std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0));
				
end vettore_ST_sel_Singola_move;


architecture behavioral of vettore_ST_sel_Singola_move is


component generatore_ST_selp is 

	generic (n	: POSITIVE  := 3);	
	
	port ( I_i:	      in std_logic_vector (integer(ceil(log2(real(n+1))))-1 downto 0);
	       I_i_meno_1:in std_logic_vector (integer(ceil(log2(real(n+1))))-1 downto 0);
		    ST_sel: 	out std_logic_vector (grandezza_gen_ST_out(n)-1 downto 0));
				
end component;


 component And_gen_ST_sel is 

	generic (l: integer := 3 ; n: integer := 3);	
	
	port ( dec_add        : in std_logic_vector(2**l -3 downto 0);
		    singolo_ST_sel : in std_logic_vector (grandezza_gen_ST_out(n)-1 downto 0);
			 ST_vettore_out : out std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0));
				
end component;




component OR_tra_vettori_ST_sel is 

	generic (l: integer := 3 ; X: integer := 5 ; n: integer := 3);	
	
	port ( ST_in    : in std_logic_vector ((X-1)*(grandezza_ST_sel(l,n))-1 downto 0);
			 ST_out   : out std_logic_vector(grandezza_ST_sel(l,n)-1 downto 0));
				
end component;



signal ST_sel_c  : std_logic_vector (((X-1)* grandezza_gen_ST_out(n) )-1 downto 0);
signal out_c     : std_logic_vector ((X-1)*(grandezza_ST_sel(l,n))-1 downto 0);



begin 


Gen: for i in 0 to (X-2) generate

										 			
           										 
			  generatore_ST_sel_i    : generatore_ST_selp 
                                    generic map (n)	
											   port map (vettore_I((i+2)*integer(ceil(log2(real(n+1))))-1 downto (i+1)*integer(ceil(log2(real(n+1))))),
											             vettore_I((i+1)*integer(ceil(log2(real(n+1))))-1 downto i*integer(ceil(log2(real(n+1))))),
															 ST_sel_c((i+1)*(grandezza_gen_ST_out(n))-1 downto i*(grandezza_gen_ST_out(n))));
										 			
										 
										 
			  And_gen_ST_sel_i       : And_gen_ST_sel
                                    generic map (l,n)	
												port map (address((i+1)*(2**l)-2 downto i*(2**l)+1), 
												          ST_sel_c((i+1)*grandezza_gen_ST_out(n)-1 downto i*grandezza_gen_ST_out(n)),
															 out_c((i+1)*(grandezza_ST_sel(l,n))-1 downto i*(grandezza_ST_sel(l,n))));
										 
										 
end generate Gen;	


OR_tra_vettori_ST_sel_1 : OR_tra_vettori_ST_sel
                          generic map (l,X,n)
						        port map (out_c, vettore_ST_sel);
								  
end behavioral;
						 
						